/* bits.c
 * test efektivity algoritmu
 * jen mereni ("driver")
 */

#include <stdio.h>
#include <stdlib.h>
#include "bitcount.h"

#define rdtsc()  __builtin_ia32_rdtsc()

#define PRINT1 0
#define PRINT2 0

#define N 32
int ucmp(const void *a, const void *b)
{
    return *(unsigned *) a < *(unsigned *) b;
}

unsigned num=0;        // extern

double test(unsigned (*f) (unsigned long), unsigned (*e) (unsigned long))
{
    long long t, t1, t2, t3;
    double avgt;
    int i, j;
    unsigned long sumt = 0;
#if PRINT1
    printf("* ");
#endif
    for (i = 0; i < 32; i++) {
	unsigned long ta[N];
	for (j = 0; j < N; j++) {
#if 0
	    unsigned long x = 1 << i;
#else
	    unsigned long x = rand();
#endif
            /* merime 4 operace a secteme vsechny vysledky */
	    t1 = rdtsc();
	    num += e(x);	        /* kompenzace volani funkce */
	    num += e(x);	        /* kompenzace volani funkce */
	    num += e(x);	        /* kompenzace volani funkce */
	    num += e(x);	        /* kompenzace volani funkce */
	    t2 = rdtsc();
	    num += f(x);
	    num += f(x);
	    num += f(x);
	    num += f(x);
	    t3 = rdtsc();
	    t = t3 - t2 - (t2 - t1);
            t /= 4;                     /* 4 operace */
	    ta[j] = t;		        /* zaznam mereni */
	    if (bitcount1(x)!=bitcount2(x))
		fprintf(stderr, "bitcount() test error\n");
	}
	qsort(ta, N, sizeof(unsigned), ucmp);
#if PRINT1
	printf("%d%c", ta[N / 2], (i == 32 - 1) ? '\n' : ' ');
#endif
#if PRINT2
	printf("# ");
	for (int k = 0; k < N; k++)
	    printf("%d%c", ta[k], (k == N - 1) ? '\n' : ' ');
#endif
	sumt += ta[N / 2];    /* median */
    }
    avgt = sumt / 32.0;
    return avgt;
}

int main(int argc, char *argv[])
{
    int i;
    const char *s = argv[0];
    test(bitcount1, empty);
    test(bitcount1, empty);
    test(bitcount2, empty);
    test(bitcount2, empty);
    for(i=0;i<10;i++)
        printf("%6.1f clocks bitcount1 (%s)\n", test(bitcount1, empty), s);
    for(i=0;i<10;i++)
        printf("%6.1f clocks bitcount2 (%s)\n", test(bitcount2, empty), s);
}
