
// test performance of float and int division

// try: gcc -O2
// try: gcc -O2 -m32
// try: gcc -Os
// try: gcc -O3 -march=native

#include <stdio.h>
#include <time.h>

#define N 1000000000            // at most INT_MAX

#define RUNTEST(T)              \
{                               \
    T x = N;                    \
    clock_t start = clock();    \
    for(int i=1; i<=N; ++i)     \
        x/=i;                   \
    clock_t end = clock();      \
    printf("%5.2f : " #T "\n", (double)(end-start)/CLOCKS_PER_SEC); \
    result+=x;                  \
}

// test
int main(int argc, char *argv[]) {
    int result=0;
    RUNTEST(int);
    RUNTEST(long long);
    RUNTEST(float);
    RUNTEST(double);
    RUNTEST(long double);
    return result>1;
}

