
/* Demo: << >> bit shift operators
 *
 *   gcc ijc-shift-test1.c
 *   gcc ijc-shift-test1.c -O3
 *
 */

#include <stdio.h>

#define PRINT(x) do {                                   \
        unsigned int v=(x);                             \
        printf("( %-8s ) == % -11d == %10uU == 0x%08X \n", #x, v, v, v); \
    } while(0)

int main(void) {
    int i;
    unsigned u;

    printf("sizeof(int)=%zd\n",sizeof(int));
    printf("\n");
    PRINT( i = -10 );
    PRINT( u = -10 );

    printf("\nSigned shift right is implementation-defined:\n");
    PRINT( i>>1 );
    PRINT( u>>1 );

    printf("\nUndefined behaviour for 32bit int shift:\n");
    PRINT( i<<32 );     // warning expected
    PRINT( u<<32 );     // warning expected

    printf("\nShift (-1)>>1 is NOT the same as division (-1)/2:\n");
    PRINT( i = -1 );
    PRINT( i>>1 );
    PRINT( i/2 );

    printf("\nModulo operation works differently for signed/unsigned:\n");
    PRINT( u=i=-1 );
    PRINT( i%2 );
    PRINT( u%2 );

    printf("\netc...\n");
    PRINT( u = -1 );
    PRINT( u >>= 1 );
    PRINT( i = ~u );
    PRINT( i>>1 );
    PRINT( (i>>1)*2 );
    printf("\n");
}
