
/*  This example is inspired by:
 *  "Reciprocal Multiplication, a tutorial"
 *  Part of the Arithmetic Tutorial Collection by Douglas W. Jones
 *  THE UNIVERSITY OF IOWA Department of Computer Science
 *  Copyright © 1999, Douglas. W. Jones, with major revisions made in 2002.
 */

#include <stdio.h>      // printf
#include <stdint.h>     // uint16_t, uint32_t

// divide x by 10  (works for x < 81920, i.e. all 16bit values)
uint16_t div10(uint16_t x) {
    uint32_t a = x;
    uint16_t point8 = 0xCCCD;   // rounded 0.8 in fixed-point representation
    return (a*point8)>>(16+3);  // integer part of fixed point result / 8
}

// test all possible values
int main() {
    printf("Checking...\n");
    uint16_t i=0;
    do {
        uint16_t r1 = div10(i);
        uint16_t r2 = i/10;
        //printf("i=%u r1=%u\n", i, r1);
        if(r1!=r2)
            printf("ERROR: i=%u r1=%u\n", i, r1);
        ++i; // modular arithmetic
    } while(i!=0);
    printf("Done.\n");
}

