
/*  This example is inspired by:
 *  "Reciprocal Multiplication, a tutorial"
 *  Part of the Arithmetic Tutorial Collection by Douglas W. Jones
 *  THE UNIVERSITY OF IOWA Department of Computer Science
 *  Copyright © 1999, Douglas. W. Jones, with major revisions made in 2002.
 */

#include <stdio.h>      // printf
#include <stdint.h>     // uint64_t, uint32_t

// divide x by 10 (x*0.8/8 == x*0.1 == x/10)
uint32_t div10(uint32_t x) {
    uint64_t a = x;
    uint32_t point8 = 0xCCCCCCCD; // rounded 0.8 in fixed-point representation
    return (a*point8)>>(32+3);    // integer part of fixed point result / 8
}

// test all possible values
int main() {
    printf("Checking...\n");
    uint32_t i=0;
    do {
        uint32_t r1 = div10(i);
        uint32_t r2 = i/10;
        if(r1!=r2)
            printf("ERROR: i=%u r1=%u\n", i, r1);
        ++i; // modular arithmetic
    } while(i!=0);
    printf("Done.\n");
}

