
// small test of float/double/long double accuracy

#include <stdio.h>
#include <fenv.h>
//#pragma STDC FENV_ACCESS ON

int main(void) {
    printf("Floating point accuracy test (10 times sum 0.1)\n");
#ifdef TEST1
    fesetround(FE_TOWARDZERO);
#endif
    float f1=0.1F;
    printf("float:\n");
    printf("%.9f\n",f1);
    for(int i=0; i<9; ++i) {
        f1+=0.1F;
    }
    printf("%.9f\t",f1);
    printf("delta=%g\n",f1-1.0F);

    double d1=0.1;
    printf("double:\n");
    printf("%.17f\n",d1);
    for(int i=0; i<9; ++i) {
        d1+=0.1;
    }
    printf("%.17f\t",d1);
    printf("delta=%g\n",d1-1.0);

    long double l1=0.1L;
    printf("long double:\n");
    printf("%.21Lf\n",l1);
    for(int i=0; i<9; ++i) {
        l1+=0.1L;
    }
    printf("%.21Lf\t",l1);
    printf("delta=%Lg\n",l1-1.0L);
}
