
// test of trigonometric functions precision
// link with math library: gcc -lm

#include <stdio.h>
#include <math.h>

#ifndef M_PI
#    define M_PI 3.14159265358979323846F
#endif

double difference(float x) {
    return sinf(x) - sinf(x + 2*M_PI);    // math: should be zero
}

int main() {
    printf("Partial/Total loss of precision\n");
    printf("sin(x)-sin(x+2*\\pi) for x=10^{n}, n=1..9\n");
    float x = 1.0F;
    for(int i=1; i<=9; ++i) {
        x *= 10.0F;
        printf("%3d: % g\n", i, difference(x));
    }
}
