
set term pdf; set output "x.pdf"

set title  "numerical error for forward and central difference"
set xlabel "h"
set ylabel "abs(error)"
set grid
set logscale x
set xtics format "%.0e" font ",9"
set logscale y
set ytics format "%.0e" font ",9"
set xrange [1e-11:0.1]
set yrange [:0.1]
set key left
set xtics 10

plot "x" using ($1):(abs($3)) with linespoints lw 2 ps 0.5 title "forward", \
      "" using ($1):(abs($5)) with linespoints lw 2 ps 0.4 title "central"


