
// C language example of time(), localtime(), strftime()

#include <stdio.h>
#include <time.h>
#include <locale.h>

struct tm *localtime( const time_t *time );

int main() {
    char s[200];        // buffer for month/wday name
    setlocale(LC_TIME, "");
    time_t t = time(NULL);
    printf("time = %ld\n", t);
    printf("\n");
    struct tm *p = localtime(&t);
    if(!p) {
        fprintf(stderr,"ERROR: localtime\n");
        return 1;
    }
    struct tm tm = *p;
    printf("struct tm:\n");
    printf("---------\n");
    printf(".tm_year  = %d\n", 1900+tm.tm_year);
    printf(".tm_mon   = %d\t", 1+tm.tm_mon);
    if(strftime(s, sizeof(s), "%B", &tm))
        printf(" (%s)", s);
    printf("\n");

    printf(".tm_mday  = %d\n", 0+tm.tm_mday);

    printf(".tm_wday  = %d\t", 0+tm.tm_wday);
    if(strftime(s, sizeof(s), "%A", &tm))
        printf(" (%s)", s);
    printf("\n");

    printf("\n");
    printf(".tm_hour  = %d\n", 0+tm.tm_hour);
    printf(".tm_min   = %d\n", 0+tm.tm_min);
    printf(".tm_sec   = %d\n", 0+tm.tm_sec);
    printf("\n");
    printf(".tm_yday  = %d\n", 0+tm.tm_yday);  // 0 == 1.1.
    printf(".tm_isdst = %d\n", 0+tm.tm_isdst);
    printf("\n");
}
