
// C99: iswctype(), wctype()
// fileencoding=utf8

#include <locale.h>
#include <wchar.h>
#include <wctype.h>
#include <stdio.h>

void print(wint_t wc) {
    printf("Kategorie znaku '%lc' (\\U%08X) jsou:", wc, wc);
    static const char* const cats[] = { // vybrané kategorie
      "digit", "alpha", "space", "cntrl", "graph", "lower", "print",
    };
    for(int n = 0; n < sizeof(cats)/sizeof(cats[0]); ++n) {
        if(iswctype(wc, wctype(cats[n])))
            printf(" %s", cats[n]);
    }
    printf("\n");
}

int main(void)
{
#if 1
    const char *l = setlocale(LC_ALL, "");
#else
    const char *l = setlocale(LC_ALL, "cs_CZ.UTF-8");
#endif
    printf("Locale=%s\n", l);
    print(U'\U0001F596');
    print(U'ě');
    print(U'1');
    print(U'\t');
}

/* možný výstup:
Locale=en_GB.UTF-8
Kategorie znaku '🖖' (\U0001F596) jsou: graph print
Kategorie znaku 'ě' (\U0000011B) jsou: alpha graph lower print
Kategorie znaku '1' (\U00000031) jsou: digit graph print
Kategorie znaku '	' (\U00000009) jsou: space cntrl
*/
